
window.game_tile_size = 32
window.game_x = 20
window.game_y = 15
window.game_width = window.game_tile_size * window.game_x
window.game_height = window.game_tile_size * window.game_y

window.player_switch_pos = [256,128]
window.player_switch_v = [0,0]

window.paused = 0

window.song_playing = 0

window.powers = ['< - A', 'D - >', '[JUMP - SPACE]']

window.onload = ->
  Crafty.init window.game_width, window.game_height
  window.level = 1
  window.zone = [1,1]

  window.map = window.create_array_map()


  ###Crafty.addEvent this, Crafty.stage.elem, "mousedown", (e) ->
    Crafty.trigger "MouseDown", e
  Crafty.addEvent this, Crafty.stage.elem, "mouseup", (e) ->
    Crafty.trigger "MouseUp", e
  Crafty.addEvent this, Crafty.stage.elem, "mousemove", (e) ->
    Crafty.trigger "MouseMove", e
  ###

  Crafty.scene "loading", ->
    console.log 'loading'
    Crafty.background "#000"
    window.loadbar = Crafty.e("2D, DOM, Text").attr(
      w: 640
      h: 20
      x: 100
      y: 100
    ).text("Loading").css("text-align": "center").textFont(family: "Arial").textColor("#ffffff", 1.0)

    Crafty.audio.add 'song1', [ "audio/LD_SONG.mp3", "audio/LD_SONG.ogg"]
    Crafty.audio.add 'song2', [ "audio/LD_SONG2.mp3", "audio/LD_SONG2.ogg"]
    if window.song_playing
      Crafty.audio.stop window.song_playing
    Crafty.audio.play "song1", -1, .5
    window.song_playing = "song1"

    Crafty.load [ "./img/tiles.png" ], ->


    
              
    Crafty.scene('loadmap')
    

  Crafty.scene "loadmap", ->  
    $.ajax
      url: "./levels/"+window.zone[0]+"-"+window.zone[1]+".php"

      error: (XMLHttpRequest, textStatus, errorThrown) ->
          #create an empty map
          console.log 'no map file; creating one now'
          window.map = window.create_array_map()
          Crafty.scene "intro"

      success: (data) ->
        window.map = JSON.parse data
        console.log window.map
        Crafty.scene "intro"

  Crafty.scene "intro", ->
    
    console.log 'game started'
    window.emap_solid = window.create_array_map()
    for i, x in window.map
      for j, y in i
        if j isnt 0

          if j[2] is 1
            c = ', Collision, Solid'
          else
            c = ', Collision'

          #powerups
          if j[0] is 0 and j[1] is 15
            c += ',Wings'
          if j[0] is 1 and j[1] is 15
            c += ',Jump'

          newtile = Crafty.e("2D, Canvas, Sprite, t1 "+ c).attr(
            x: x*window.game_tile_size
            y: y*window.game_tile_size
            z: j[3]
          )

          newtile.sprite(0,0,1,1)
          newtile.sprite(j[0],j[1],1,1)
          if j[2] is 1
            newtile.collision()
          window.emap_solid[x][y] = newtile


    e = Crafty.e("Editor,2D, Canvas, Mouse, Color").attr(
      w: window.game_width
      h: window.game_height
      ).color('#000000')

    window.player = Crafty.e("Player, 2D, Canvas, Collision").attr(w:32, h:64).collision(new Crafty.polygon([24,32], [24,64], [8,64], [8,32]) )
    window.player.build()
    window.player.x = window.player_switch_pos[0]
    window.player.y = window.player_switch_pos[1]

  Crafty.scene('loading')


window.create_array_map = ->
  t = []
  l = window.game_x
  for i in [1..l]
      r = []
      for j in [1..window.game_y]
          r.push 0
      t.push r
  t








