Crafty.c "Player",
  x:0
  y:0
  w:32
  h:32
  z:50
  show_powers: ->
    s = ' <h2 id="zone"><b>ZONE : '+window.zone+'</b></h2>
      <h2><b>POWERS</b></h2>'
    for power in window.powers
      s += '<p>'+power+'</p>'
    $('#rightcolumn').html(s)

  apply_powers: ->
    if 'FLY : W - S' in window.powers
      @fly = 1

    if 'DOUBLE JUMP' in window.powers
      @djump = 1

    @show_powers()

    if @fly
      @wings = Crafty.e("2D, Canvas, Sprite, human").attr(
        h:32
        z:4900
        w:32).sprite(0,3,1,1)


  init: ->
    @requires "Gravity, WatchKeys"
    @w = 32
    @h = 32
    x:@x
    y:@y
    @speed = 3
    @ftoggle = 0
    @curranim = 'stand'
    @v.x = window.player_switch_v[0]
    @v.y = window.player_switch_v[1]
    @fly = 0
    @djump = 0
    @can_djump = 1

    @current_keys = {}

    @apply_powers()


    @body = Crafty.e("2D, Canvas, Sprite, human").attr(

      h:64
      z:5000
      w:32).sprite(0,1,1,2)



    @legs = Crafty.e("2D, Canvas, Sprite, SpriteAnimation, foot1").attr(
      x:@x
      y:@y+32
      h:32
      z:5001
      w:32).sprite(0,0,1,1).animate('run',2,0,0).animate('stand',3,0,3).animate('run',15,-1).animate('fall',3,1,3)

    @arms = Crafty.e("2D, Canvas, Sprite, SpriteAnimation, foot1").attr(
      x:@x
      y:@y
      h:32
      z:5004
      w:32).sprite(1,1,1,1).animate('run',1,1,2).animate('stand',2,2,2).animate('fall',1,2,1)



    @bind "KeyDown", (e) ->

      if e.key is Crafty.keys["SPACE"]
        if @ftoggle < 15
          @v.y = -10
        else if @djump and @can_djump
          @v.y = -10
          @can_djump = 0
      if e.key is Crafty.keys["A"]
        @legs.stop('run')
        @arms.stop('run')
        @legs.stop('stand')
        if not @legs.isPlaying( 'run')
          @legs.animate('run',20,-1)
          @arms.animate('run',30,-1)
        @body.flip('X')
        @legs.flip('X')
        @arms.flip('X')
      if e.key is Crafty.keys["D"]
        @legs.stop('run')
        @arms.stop('run')
        @legs.stop('stand')
        if not @legs.isPlaying( 'run')
          @legs.animate('run',20,-1)
          @arms.animate('run',30,-1)
        @body.unflip()
        @legs.unflip()
        @arms.unflip('X')

    @bind "KeyUp", (e) ->


    @bind "EnterFrame", (e) ->
      window.player_switch_pos = [@x, @y]
      if @x < 0 - window.game_tile_size
        window.player_switch_pos[0] = window.game_width-1
        window.player_switch_v = [@v.x,@v.y]
        window.zone[0] -= 1
        Crafty.scene('loadmap')
      if @x > window.game_width
        window.player_switch_v = [@v.x,@v.y]
        window.player_switch_pos[0] = 1
        window.zone[0] += 1
        Crafty.scene('loadmap')
      if @y > window.game_height + 64
        window.player_switch_v = [@v.x,@v.y]
        window.player_switch_pos[1] = -63
        window.zone[1] += 1
        Crafty.scene('loadmap')
      if @y+64 < 0
        window.player_switch_v = [@v.x,@v.y]
        window.player_switch_pos[1] = window.game_height-100
        window.zone[1] -= 1
        Crafty.scene('loadmap')

      if @KeyActive(Crafty.keys["A"])
        
        if Math.abs(@v.x) < @speed
          @v.x += -.8
      if @KeyActive(Crafty.keys["D"])
        
        if Math.abs(@v.x) < @speed
          @v.x += .8

      @v.x *= .95

      # FLYING THINGS

      if @fly
        if @KeyActive(Crafty.keys["W"])
          @arms.stop('run')
          @arms.stop('stand')
          @arms.animate('fall', 10, -1)
          if @v.y > -@speed
            @v.y += -1
        else
          @arms.stop('fall')
        if @KeyActive(Crafty.keys["S"])
          if @v.y < @speed
            @v.y += 1




      h = @hit "Solid"
      if h
        cx = 0
        cy = 0
        for obj in h

          cx += obj.normal.x
          cy += obj.normal.y
        if cy isnt 0
          @v.y = 0 + cy*.4#*-obj.overlap
        if cx isnt 0
          @v.x = 0 + cx*.4#*-obj.overlap

        if Math.abs(cy) isnt 0
          if not @KeyActive(Crafty.keys["A"]) and not @KeyActive(Crafty.keys["D"])

            @legs.animate('stand', 10, -1)
            @arms.animate('stand', 10, -1)
          else

            if not @legs.isPlaying('run')
              console.log 'run'
              @legs.stop('run')
              @arms.stop('run')
              @legs.animate('run',20, -1)
              @arms.animate('run',30, -1)
          @ftoggle = 0
          @can_djump = 1
      else #
        @ftoggle += 1
        if @ftoggle > 30
          @legs.animate('fall', 10, -1)
          @arms.stop('run')
          @arms.stop('stand')
          if !@KeyActive(Crafty.keys["W"])
            @arms.animate('run', 10, -1)

      h = @hit "Wings"
      if h
        console.log 'WINGS'
        for obj in h
          window.powers.push( 'FLY : W - S')
          @show_powers()
          obj.obj.destroy()
          @apply_powers()
          @wings.x = @x
          @wings.y = @y
          @_children.push @wings

      h = @hit "Jump"
      if h
        console.log 'JUMP'
        for obj in h
          window.powers.push( 'DOUBLE JUMP')
          @show_powers()
          obj.obj.destroy()
        @apply_powers()

    this

  build: ->

    @_children.push @body
    @_children.push @legs
    @_children.push @arms
    if @fly
      @_children.push @wings





