// Generated by CoffeeScript 1.3.1
(function() {
  var __indexOf = [].indexOf || function(item) { for (var i = 0, l = this.length; i < l; i++) { if (i in this && this[i] === item) return i; } return -1; };

  Crafty.c("WatchKeys", {
    /*
    		Keeps track of which keys are currently pressed
    */

    _current_keys: {},
    init: function() {
      this.bind("KeyDown", function(e) {
        return this._current_keys[e.key] = true;
      });
      return this.bind("KeyUp", function(e) {
        return delete this._current_keys[e.key];
      });
    },
    KeyActive: function(num) {
      return this._current_keys[num];
    }
  });

  Crafty.c("Velocity", {
    /*
    		Provides entity with a vecctor2D that is applied to object position.
    		_clamp sets the maximum length of this
    */

    _clamp: 7,
    init: function() {
      console.log('Velocity component init');
      this.v = new window.Vector2;
      this.bind("EnterFrame", function(e) {
        if (window.paused !== 1) {
          if (this.v.length() > this._clamp) {
            this.v = this.v.normalize();
            this.v = this.v.scale(this._clamp);
          }
          this.x += this.v.x;
          return this.y += this.v.y;
        }
      });
      return this;
    }
  });

  Crafty.c("Gravity", {
    _amount: .3,
    init: function() {
      if (window.paused !== 1) {
        this.requires("Velocity");
        return this.bind("EnterFrame", function(e) {
          if (this.wings) {
            return this.v.y += .1;
          } else {
            return this.v.y += this._amount;
          }
        });
      }
    }
  });

  Crafty.c("Wings", {
    init: function() {
      if (__indexOf.call(window.powers, 'FLY : W - S') >= 0) {
        return this.destroy();
      }
    }
  });

  Crafty.c("Jump", {
    init: function() {
      if (__indexOf.call(window.powers, 'DOUBLE JUMP') >= 0) {
        return this.destroy();
      }
    }
  });

}).call(this);
