// Generated by CoffeeScript 1.3.1
(function() {

  Crafty.c("Tile_Select", {
    x: 0,
    y: 0,
    w: window.game_width,
    h: window.game_height,
    z: 1000,
    sheet: 't1',
    init: function() {
      var g, i, j, _i, _j;
      this.tiles = [];
      window.indicator = Crafty.e("2D, Canvas, tile_select").attr({
        x: 30 + window.selected_tile[0] * window.game_tile_size + window.selected_tile[0],
        y: 30 + window.selected_tile[1] * window.game_tile_size + window.selected_tile[1],
        w: 32,
        h: 32,
        z: 99000
      });
      for (i = _i = 0; _i <= 15; i = ++_i) {
        for (j = _j = 0; _j <= 10; j = ++_j) {
          g = Crafty.e("2D, Canvas," + this.sheet + ", Mouse").attr({
            x: i * (window.game_tile_size + 1) + 30,
            y: j * (window.game_tile_size + 1) + 30,
            w: window.game_tile_size,
            h: window.game_tile_size,
            z: 10001
          }).sprite(i, j, 1, 1);
          g.bind("MouseDown", function(e) {
            window.selected_tile = this.index;
            window.indicator.x = this.x;
            window.indicator.y = this.y;
            console.log;
            if (this.index[1] > 6) {
              window.selected_solid = 0;
              return $('#l-solid').fadeTo(20, .3);
            } else {
              window.selected_solid = 1;
              return $('#l-solid').fadeTo(20, 1);
            }
          });
          g.index = [i, j];
          this.tiles.push(g);
        }
      }
      $('#l-solid').click(function() {
        if (window.selected_solid === 1) {
          window.selected_solid = 0;
          return $('#l-solid').fadeTo(20, .3);
        } else {
          window.selected_solid = 1;
          return $('#l-solid').fadeTo(20, 1);
        }
      });
      return this;
    }
  });

  Crafty.c("Editor", {
    w: window.game_width,
    h: window.game_height,
    init: function() {
      window.editor = this;
      this.x = window.game_width;
      this.y = window.game_height;
      window.selected_tile = [0, 0];
      window.selected_solid = 1;
      window.selected_z = 50;
      this.drawing = 0;
      this.choosing = 0;
      this.needs_save = 0;
      this.placed_at = [-500, -500];
      console.log('editor init');
      $('#overlay').html("      <img id='l-edit' src='./img/edit.jpg' style='cursor:pointer;' /><img id='l-save' src='./img/save.jpg' style='cursor:pointer;' />       <img id='l-solid' src='./img/solid.jpg' style='cursor:pointer;' />      <img id='l-tile' src='./img/tile.jpg' style='cursor:pointer;' />    ");
      $('#l-edit').click(function() {
        return window.editor.handle_edit_toggle();
      });
      $('#l-tile').click(function() {
        return window.editor.handle_tile_select();
      });
      $('#l-save').click(function() {
        var parameters;
        if (window.paused === 1) {
          parameters = {
            "map": JSON.stringify(window.map),
            "x": window.zone[0],
            "y": window.zone[1]
          };
          $.post('./save_level.php', parameters, function(data, statusText) {
            return console.log(data);
          });
          this.needs_save = 0;
          return $('#l-save').fadeTo(100, .3);
        }
      });
      this.bind("EnterFrame", function(e) {});
      this.bind("MouseDown", function(e) {
        if (window.paused === 1) {
          this.drawing = 1;
          return this.place_tile(e.clientX, e.clientY);
        }
      });
      this.bind("MouseUp", function(e) {
        this.drawing = 0;
        return this.placed_at = [-500, -500];
      });
      this.bind("MouseMove", function(e) {
        if (window.paused === 1) {
          return this.place_tile(e.clientX, e.clientY);
        }
      });
      this.bind("KeyDown", function(e) {
        if (window.paused === 1) {
          if (e.key === Crafty.keys["T"]) {
            this.handle_tile_select();
          }
        }
        if (e.key === Crafty.keys["K"]) {
          return this.handle_edit_toggle();
        }
      });
      return this;
    },
    handle_edit_toggle: function() {
      if (window.paused === 0) {
        window.paused = 1;
        $('#l-edit').fadeTo(100, .3);
        $('#l-solid, #l-tile').fadeIn(100);
        if (this.needs_save === 0) {
          return $('#l-save').fadeTo(100, .3);
        } else {
          return $('#l-save').fadeTo(100, 1);
        }
      } else {
        if (this.choosing === 1) {
          this.handle_tile_select();
        }
        window.paused = 0;
        $('#l-edit').fadeTo(100, 1);
        return $('#l-save, #l-solid, #l-tile').fadeOut(100);
      }
    },
    handle_tile_select: function() {
      var t, _i, _len, _ref;
      if (window.paused === 1) {
        if (this.choosing === 0) {
          this.choosing = 1;
          $('#l-tile').fadeTo(100, .3);
          return this.sheet = Crafty.e("2D, Canvas, Color, Tile_Select").color("#969696").attr({
            x: 0,
            y: 0,
            w: window.game_width,
            h: window.game_height,
            z: 1000
          });
        } else {
          $('#l-tile').fadeTo(100, 1);
          _ref = this.sheet.tiles;
          for (_i = 0, _len = _ref.length; _i < _len; _i++) {
            t = _ref[_i];
            t.destroy();
          }
          window.indicator.destroy();
          this.sheet.destroy();
          return this.choosing = 0;
        }
      }
    },
    place_tile: function(eX, eY) {
      var ccc, gx, gy, xx, yy;
      eX = eX - $('#cr-stage').offset().left;
      eY = eY - $('#cr-stage').offset().top;
      xx = eX - eX % window.game_tile_size;
      yy = eY - eY % window.game_tile_size;
      gx = xx / window.game_tile_size;
      gy = yy / window.game_tile_size;
      console.log(eX, eY);
      if (this.drawing === 1) {
        if (this.placed_at[0] !== xx || this.placed_at[1] !== yy) {
          console.log(this.placed_at);
          this.placed_at = [xx, yy];
          console.log(this.placed_at);
          if (window.emap_solid[gx][gy] !== 0) {
            window.emap_solid[gx][gy].destroy();
          }
          console.log(window.selected_solid);
          window.map[gx][gy] = [window.selected_tile[0], window.selected_tile[1], window.selected_solid, window.selected_z];
          console.log(window.map[gx][gy]);
          if (window.selected_solid) {
            ccc = ',Solid';
          } else {
            ccc = '';
          }
          window.emap_solid[gx][gy] = Crafty.e("2D, Canvas, t1, Collision" + ccc).attr({
            x: eX - eX % window.game_tile_size,
            y: eY - eY % window.game_tile_size,
            z: 10
          }).collision().sprite(window.selected_tile[0], window.selected_tile[1], 1, 1);
          if (this.needs_save === 0) {
            this.needs_save = 1;
            return $('#l-save').fadeTo(100, 1);
          }
        }
      }
    }
  });

}).call(this);
