// Generated by CoffeeScript 1.3.1
(function() {

  window.game_tile_size = 32;

  window.game_x = 20;

  window.game_y = 15;

  window.game_width = window.game_tile_size * window.game_x;

  window.game_height = window.game_tile_size * window.game_y;

  window.player_switch_pos = [256, 128];

  window.player_switch_v = [0, 0];

  window.paused = 0;

  window.song_playing = 0;

  window.powers = ['< - A', 'D - >', '[JUMP - SPACE]'];

  window.onload = function() {
    Crafty.init(window.game_width, window.game_height);
    window.level = 1;
    window.zone = [1, 1];
    window.map = window.create_array_map();
    /*Crafty.addEvent this, Crafty.stage.elem, "mousedown", (e) ->
      Crafty.trigger "MouseDown", e
    Crafty.addEvent this, Crafty.stage.elem, "mouseup", (e) ->
      Crafty.trigger "MouseUp", e
    Crafty.addEvent this, Crafty.stage.elem, "mousemove", (e) ->
      Crafty.trigger "MouseMove", e
    */

    Crafty.scene("loading", function() {
      console.log('loading');
      Crafty.background("#000");
      window.loadbar = Crafty.e("2D, DOM, Text").attr({
        w: 640,
        h: 20,
        x: 100,
        y: 100
      }).text("Loading").css({
        "text-align": "center"
      }).textFont({
        family: "Arial"
      }).textColor("#ffffff", 1.0);
      Crafty.audio.add('song1', ["audio/LD_SONG.mp3", "audio/LD_SONG.ogg"]);
      Crafty.audio.add('song2', ["audio/LD_SONG2.mp3", "audio/LD_SONG2.ogg"]);
      if (window.song_playing) {
        Crafty.audio.stop(window.song_playing);
      }
      Crafty.audio.play("song1", -1, .5);
      window.song_playing = "song1";
      Crafty.load(["./img/tiles.png"], function() {});
      return Crafty.scene('loadmap');
    });
    Crafty.scene("loadmap", function() {
      return $.ajax({
        url: "./levels/" + window.zone[0] + "-" + window.zone[1] + ".php",
        error: function(XMLHttpRequest, textStatus, errorThrown) {
          console.log('no map file; creating one now');
          window.map = window.create_array_map();
          return Crafty.scene("intro");
        },
        success: function(data) {
          window.map = JSON.parse(data);
          console.log(window.map);
          return Crafty.scene("intro");
        }
      });
    });
    Crafty.scene("intro", function() {
      var c, e, i, j, newtile, x, y, _i, _j, _len, _len1, _ref;
      console.log('game started');
      window.emap_solid = window.create_array_map();
      _ref = window.map;
      for (x = _i = 0, _len = _ref.length; _i < _len; x = ++_i) {
        i = _ref[x];
        for (y = _j = 0, _len1 = i.length; _j < _len1; y = ++_j) {
          j = i[y];
          if (j !== 0) {
            if (j[2] === 1) {
              c = ', Collision, Solid';
            } else {
              c = ', Collision';
            }
            if (j[0] === 0 && j[1] === 15) {
              c += ',Wings';
            }
            if (j[0] === 1 && j[1] === 15) {
              c += ',Jump';
            }
            newtile = Crafty.e("2D, Canvas, Sprite, t1 " + c).attr({
              x: x * window.game_tile_size,
              y: y * window.game_tile_size,
              z: j[3]
            });
            newtile.sprite(0, 0, 1, 1);
            newtile.sprite(j[0], j[1], 1, 1);
            if (j[2] === 1) {
              newtile.collision();
            }
            window.emap_solid[x][y] = newtile;
          }
        }
      }
      e = Crafty.e("Editor,2D, Canvas, Mouse, Color").attr({
        w: window.game_width,
        h: window.game_height
      }).color('#000000');
      window.player = Crafty.e("Player, 2D, Canvas, Collision").attr({
        w: 32,
        h: 64
      }).collision(new Crafty.polygon([24, 32], [24, 64], [8, 64], [8, 32]));
      window.player.build();
      window.player.x = window.player_switch_pos[0];
      return window.player.y = window.player_switch_pos[1];
    });
    return Crafty.scene('loading');
  };

  window.create_array_map = function() {
    var i, j, l, r, t, _i, _j, _ref;
    t = [];
    l = window.game_x;
    for (i = _i = 1; 1 <= l ? _i <= l : _i >= l; i = 1 <= l ? ++_i : --_i) {
      r = [];
      for (j = _j = 1, _ref = window.game_y; 1 <= _ref ? _j <= _ref : _j >= _ref; j = 1 <= _ref ? ++_j : --_j) {
        r.push(0);
      }
      t.push(r);
    }
    return t;
  };

}).call(this);
